gfxReceiverId = 1;

// Create a new shelter
const shelter = await new webR.Shelter();

// Main invocation loop
while (true) {
	const code = await codea.recv();
	
	let result, output;
	try {
		let obj = await shelter.captureR(code);
		result = await obj.result.toJs();
		
		let printOutput = "";
		for (let entry of obj.output) {
			if (entry.type === "stdout") {
				printOutput += entry.data + "\n";
			}
		}
		if (printOutput.length > 0) { print(printOutput); }
		
	} catch(e) {
		error(e.message);
	} finally {
		shelter.purge();
	}
	
	// Restructure the result into an object suitable for Codea
	const tresult = transferableResult(result);
	
	codea.send({
		data: tresult,
		id: 2
	});
}